diff --git a/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java b/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
index 5e06c9c25..1e4457da4 100644
--- a/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
+++ b/game/client/src/main/java/net/betterthanadventure/utils/DataDumper.java
@@ -71,8 +71,7 @@ public class DataDumper implements MinecraftAccessor {
         Blocks.init();
         Items.init();
 
-        File wikiDumpFile = new File(getMinecraftDir(), "infodump");
-        wikiDumpFile.mkdirs();
+        File wikiDumpFile = DumpFolder.resolve(getMinecraftDir());
         BufferedWriter writer;
 
         writer = new BufferedWriter(new FileWriter(new File(wikiDumpFile, "blocks.csv")));
diff --git a/game/client/src/main/java/net/betterthanadventure/utils/DumpFolder.java b/game/client/src/main/java/net/betterthanadventure/utils/DumpFolder.java
new file mode 100644
index 000000000..c2596db40
--- /dev/null
+++ b/game/client/src/main/java/net/betterthanadventure/utils/DumpFolder.java
@@ -0,0 +1,21 @@
+package net.betterthanadventure.utils;
+
+import org.jetbrains.annotations.NotNull;
+
+import java.io.File;
+
+/**
+ * Shared location for all debug dump output (data dumper CSVs, wiki dump, inventory sprites).
+ */
+public final class DumpFolder {
+    /** Name of the dump folder inside the Minecraft directory. */
+    public static final String NAME = "dump";
+
+    private DumpFolder() {}
+
+    public static @NotNull File resolve(@NotNull File minecraftDir) {
+        final File dir = new File(minecraftDir, NAME);
+        dir.mkdirs();
+        return dir;
+    }
+}
diff --git a/game/client/src/main/java/net/betterthanadventure/utils/InvSpriteAPNGDumper.java b/game/client/src/main/java/net/betterthanadventure/utils/InvSpriteAPNGDumper.java
new file mode 100644
index 000000000..438361555
--- /dev/null
+++ b/game/client/src/main/java/net/betterthanadventure/utils/InvSpriteAPNGDumper.java
@@ -0,0 +1,213 @@
+package net.betterthanadventure.utils;
+
+import com.mojang.logging.LogUtils;
+import net.betterthanadventure.utils.InvSpriteDumper.InvSpriteEntry;
+import net.minecraft.client.Minecraft;
+import org.jetbrains.annotations.NotNull;
+import org.slf4j.Logger;
+
+import java.awt.image.BufferedImage;
+import java.io.BufferedOutputStream;
+import java.io.ByteArrayOutputStream;
+import java.io.Closeable;
+import java.io.DataOutputStream;
+import java.io.File;
+import java.io.IOException;
+import java.io.OutputStream;
+import java.nio.file.Files;
+import java.util.List;
+import java.util.zip.CRC32;
+import java.util.zip.Deflater;
+
+
+public final class InvSpriteAPNGDumper {
+    private static final Logger LOGGER = LogUtils.getLogger();
+
+    private static final int DEFAULT_FRAME_COUNT = 60;
+    private static final int DEFAULT_TICKS_PER_FRAME = 1;
+
+    private InvSpriteAPNGDumper() {}
+
+    public static @NotNull File dump(@NotNull File minecraftDir) throws IOException {
+        return dump(minecraftDir, DEFAULT_FRAME_COUNT, DEFAULT_TICKS_PER_FRAME);
+    }
+
+    public static @NotNull File dump(@NotNull File minecraftDir, int frameCount, int ticksPerFrame) throws IOException {
+        final File dumpDir = DumpFolder.resolve(minecraftDir);
+        final File apngFile = new File(dumpDir, "InvSprite.apng");
+
+        final Minecraft mc = Minecraft.getMinecraft();
+        final List<InvSpriteEntry> entries = InvSpriteDumper.collectInvSpriteEntries();
+
+        final int[] fbo = InvSpriteDumper.createFramebuffer();
+        final var originalColors = InvSpriteDumper.applyBiomeSeasonColors();
+        try (APNGSequenceWriter apng = new APNGSequenceWriter(apngFile, frameCount, ticksPerFrame * 50, true)) {
+            // Render and stream each frame
+            for (int frame = 0; frame < frameCount; frame++) {
+                advanceAnimations(mc, ticksPerFrame);
+                final BufferedImage sheet = InvSpriteDumper.newSheet(entries.size());
+                InvSpriteDumper.renderSheet(fbo[1], entries, sheet);
+                apng.writeFrame(sheet);
+            }
+        } finally {
+            InvSpriteDumper.restoreBlockColors(originalColors);
+            InvSpriteDumper.destroyFramebuffer(fbo);
+        }
+
+        LOGGER.info("Dumped {} frame animated inventory sprite sheet to {}", frameCount, apngFile.getName());
+        return dumpDir;
+    }
+
+    private static void advanceAnimations(@NotNull Minecraft mc, int ticks) {
+        for (int i = 0; i < ticks; i++) {
+            mc.textureManager.updateDynamicTextures(false);
+        }
+    }
+
+    //modified apng writer
+    private static final class APNGSequenceWriter implements Closeable {
+        private static final byte[] SIGNATURE = {(byte) 0x89, 'P', 'N', 'G', '\r', '\n', 0x1A, '\n'};
+
+        private final DataOutputStream out;
+        private final int frameCount;
+        private final int delayNum;
+        private final int numPlays;
+        private final CRC32 crc = new CRC32();
+
+        private int sequenceNumber = 0;
+        private int width = -1;
+        private int height = -1;
+        private boolean wroteHeader = false;
+        private boolean wroteFirstFrame = false;
+
+        APNGSequenceWriter(@NotNull File file, int frameCount, int delayMillis, boolean loop) throws IOException {
+            this.frameCount = frameCount;
+            this.delayNum = Math.max(1, delayMillis);
+            // num_plays of 0 means loop forever; otherwise play once.
+            this.numPlays = loop ? 0 : 1;
+            this.out = new DataOutputStream(new BufferedOutputStream(Files.newOutputStream(file.toPath())));
+            this.out.write(SIGNATURE);
+        }
+
+        void writeFrame(@NotNull BufferedImage frame) throws IOException {
+            if (!this.wroteHeader) {
+                this.width = frame.getWidth();
+                this.height = frame.getHeight();
+                writeHeaderChunks();
+                this.wroteHeader = true;
+            } else if (frame.getWidth() != this.width || frame.getHeight() != this.height) {
+                throw new IOException("APNG frames must all share the same dimensions");
+            }
+
+            writeFrameControl();
+
+            final byte[] compressed = deflate(toRawScanlines(frame));
+            if (!this.wroteFirstFrame) {
+                writeChunk("IDAT", compressed);
+                this.wroteFirstFrame = true;
+            } else {
+                // fdAT data is prefixed with its own sequence number, followed by the compressed scanlines.
+                final byte[] data = new byte[compressed.length + 4];
+                writeInt(data, 0, this.sequenceNumber++);
+                System.arraycopy(compressed, 0, data, 4, compressed.length);
+                writeChunk("fdAT", data);
+            }
+        }
+
+        private void writeHeaderChunks() throws IOException {
+            final byte[] ihdr = new byte[13];
+            writeInt(ihdr, 0, this.width);
+            writeInt(ihdr, 4, this.height);
+            ihdr[8] = 8;  // bit depth
+            ihdr[9] = 6;  // color type: truecolor with alpha (RGBA)
+            ihdr[10] = 0; // compression: deflate
+            ihdr[11] = 0; // filter: adaptive
+            ihdr[12] = 0; // interlace: none
+            writeChunk("IHDR", ihdr);
+
+            final byte[] actl = new byte[8];
+            writeInt(actl, 0, this.frameCount);
+            writeInt(actl, 4, this.numPlays);
+            writeChunk("acTL", actl);
+        }
+
+        private void writeFrameControl() throws IOException {
+            final byte[] fctl = new byte[26];
+            writeInt(fctl, 0, this.sequenceNumber++);
+            writeInt(fctl, 4, this.width);
+            writeInt(fctl, 8, this.height);
+            writeInt(fctl, 12, 0); // x offset
+            writeInt(fctl, 16, 0); // y offset
+            writeShort(fctl, 20, this.delayNum); // delay numerator (ms)
+            writeShort(fctl, 22, 1000);    // delay denominator -> delay in milliseconds
+            fctl[24] = 1; // dispose_op = APNG_DISPOSE_OP_BACKGROUND: clear to transparent before next frame
+            fctl[25] = 0; // blend_op = APNG_BLEND_OP_SOURCE: overwrite pixels (keep exact alpha)
+            writeChunk("fcTL", fctl);
+        }
+
+        private byte @NotNull [] toRawScanlines(@NotNull BufferedImage image) {
+            final int w = this.width;
+            final int h = this.height;
+            final byte[] raw = new byte[h * (1 + w * 4)];
+            final int[] row = new int[w];
+            int pos = 0;
+            for (int y = 0; y < h; y++) {
+                image.getRGB(0, y, w, 1, row, 0, w);
+                raw[pos++] = 0; // filter type: None
+                for (int x = 0; x < w; x++) {
+                    final int argb = row[x];
+                    raw[pos++] = (byte) ((argb >> 16) & 0xFF);  // R
+                    raw[pos++] = (byte) ((argb >> 8) & 0xFF);   // G
+                    raw[pos++] = (byte) (argb & 0xFF);          // B
+                    raw[pos++] = (byte) ((argb >>> 24) & 0xFF); // A
+                }
+            }
+            return raw;
+        }
+
+        private static byte @NotNull [] deflate(byte @NotNull [] data) {
+            final Deflater deflater = new Deflater(Deflater.BEST_COMPRESSION);
+            deflater.setInput(data);
+            deflater.finish();
+            final ByteArrayOutputStream buffer = new ByteArrayOutputStream(Math.max(64, data.length / 2));
+            final byte[] chunk = new byte[8192];
+            while (!deflater.finished()) {
+                final int n = deflater.deflate(chunk);
+                buffer.write(chunk, 0, n);
+            }
+            deflater.end();
+            return buffer.toByteArray();
+        }
+
+        private void writeChunk(@NotNull String type, byte @NotNull [] data) throws IOException {
+            this.out.writeInt(data.length);
+            final byte[] typeBytes = type.getBytes(java.nio.charset.StandardCharsets.US_ASCII);
+            this.out.write(typeBytes);
+            this.out.write(data);
+
+            this.crc.reset();
+            this.crc.update(typeBytes);
+            this.crc.update(data);
+            this.out.writeInt((int) this.crc.getValue());
+        }
+
+        private static void writeInt(byte @NotNull [] dst, int offset, int value) {
+            dst[offset] = (byte) ((value >>> 24) & 0xFF);
+            dst[offset + 1] = (byte) ((value >>> 16) & 0xFF);
+            dst[offset + 2] = (byte) ((value >>> 8) & 0xFF);
+            dst[offset + 3] = (byte) (value & 0xFF);
+        }
+
+        private static void writeShort(byte @NotNull [] dst, int offset, int value) {
+            dst[offset] = (byte) ((value >>> 8) & 0xFF);
+            dst[offset + 1] = (byte) (value & 0xFF);
+        }
+
+        @Override
+        public void close() throws IOException {
+            try (OutputStream ignored = this.out) {
+                writeChunk("IEND", new byte[0]);
+            }
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/betterthanadventure/utils/InvSpriteDumper.java b/game/client/src/main/java/net/betterthanadventure/utils/InvSpriteDumper.java
new file mode 100644
index 000000000..079891e1b
--- /dev/null
+++ b/game/client/src/main/java/net/betterthanadventure/utils/InvSpriteDumper.java
@@ -0,0 +1,373 @@
+package net.betterthanadventure.utils;
+
+import com.mojang.logging.LogUtils;
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.Lighting;
+import net.minecraft.client.render.block.color.BlockColor;
+import net.minecraft.client.render.block.color.BlockColorCustom;
+import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.colorizer.ColorMap;
+import net.minecraft.client.render.colorizer.Colorizer;
+import net.minecraft.client.render.colorizer.Colorizers;
+import net.minecraft.client.render.item.model.ItemModel;
+import net.minecraft.client.render.item.model.ItemModelDispatcher;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.texturepack.TexturePack;
+import net.minecraft.client.util.helper.Buffer;
+import net.minecraft.client.util.helper.Textures;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.IPainted;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemBucket;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.helper.DyeColor;
+import net.minecraft.core.util.helper.LightIndexHelper;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.biome.Biomes;
+import net.minecraft.core.world.pos.TilePosc;
+import net.minecraft.core.world.season.Seasons;
+import org.jetbrains.annotations.NotNull;
+import org.lwjgl.opengl.GL41;
+import org.slf4j.Logger;
+
+import java.awt.image.BufferedImage;
+import java.io.File;
+import java.io.IOException;
+import java.io.Writer;
+import java.nio.ByteBuffer;
+import java.nio.charset.StandardCharsets;
+import java.nio.file.Files;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.LinkedHashMap;
+import java.util.List;
+import java.util.Map;
+
+/**
+ * Debug utility that renders every registered block and item exactly as it appears in the inventory
+ * into a single {@code InvSprite.png} sheet and writes a Lua module mapping each name to its sprite index,
+ * matching the format used by the BTA wiki.
+ */
+public final class InvSpriteDumper {
+    private static final Logger LOGGER = LogUtils.getLogger();
+
+    private static final int SPRITE_SIZE = 32;
+    private static final int SHEET_SIZE = 512;
+    private static final int COLUMNS = SHEET_SIZE / SPRITE_SIZE;
+    private static final int FILLER_INDEX = 0;
+    private static final int GENERATED_START_INDEX = 500;
+
+    private InvSpriteDumper() {}
+
+    public static @NotNull File dump(@NotNull File minecraftDir) throws IOException {
+        final File dumpDir = DumpFolder.resolve(minecraftDir);
+
+        final List<InvSpriteEntry> entries = collectInvSpriteEntries();
+
+        final BufferedImage sheet = newSheet(entries.size());
+
+        final int[] fbo = createFramebuffer();
+        // Render biome/season as if in a mid-summer forest
+        final Map<Block<?>, BlockColor> originalColors = applyBiomeSeasonColors();
+        try {
+            renderSheet(fbo[1], entries, sheet);
+        } finally {
+            restoreBlockColors(originalColors);
+            destroyFramebuffer(fbo);
+        }
+
+        final File pngFile = new File(dumpDir, "InvSprite.png");
+        Textures.saveImage(pngFile, sheet);
+
+        final File luaFile = new File(dumpDir, "invsprite.lua");
+        try (Writer writer = Files.newBufferedWriter(luaFile.toPath(), StandardCharsets.UTF_8)) {
+            writeLua(writer, entries);
+        }
+
+        LOGGER.info("Dumped {} inventory sprites to {} and {}", entries.size(), pngFile.getName(), luaFile.getName());
+        return dumpDir;
+    }
+
+    private static void writeLua(@NotNull Writer writer, @NotNull List<InvSpriteEntry> entries) throws IOException {
+        writer.write("return {\n");
+        writer.write("\tsettings = {\n");
+        writer.write("\t\talign = 'middle',\n");
+        writer.write("\t\timage = 'InvSprite.png',\n");
+        writer.write("\t\tsheetsize = " + SHEET_SIZE + ",\n");
+        writer.write("\t\tsize = " + SPRITE_SIZE + ",\n");
+        writer.write("\t},\n");
+        writer.write("\tids = {\n");
+        writer.write("\t\t-- Manually-added entries (ex. removed/legacy features) occupy indices " + FILLER_INDEX + "-" + (GENERATED_START_INDEX - 1) + ".\n");
+        writer.write("\t\t[\"Filler\"] = " + FILLER_INDEX + ",\n");
+        writer.write("\t\t-- Generated entries start at " + GENERATED_START_INDEX + ".\n");
+        for (int i = 0; i < entries.size(); i++) {
+            writer.write("\t\t[\"" + escape(entries.get(i).name()) + "\"] = " + (GENERATED_START_INDEX + i) + ",\n");
+        }
+        writer.write("\t}\n");
+        writer.write("}\n");
+    }
+
+    static @NotNull BufferedImage newSheet(int entryCount) {
+        final int maxIndex = Math.max(GENERATED_START_INDEX + entryCount - 1, FILLER_INDEX);
+        final int rows = maxIndex / COLUMNS + 1;
+        return new BufferedImage(SHEET_SIZE, rows * SPRITE_SIZE, BufferedImage.TYPE_INT_ARGB);
+    }
+
+    static void renderSheet(int colorTexture, @NotNull List<InvSpriteEntry> entries, @NotNull BufferedImage sheet) {
+        // Filler stone block at index 0; manual (removed/legacy) entries occupy indices up to GENERATED_START_INDEX.
+        blit(sheet, renderSprite(colorTexture, new ItemStack(Blocks.STONE, 1, 0)), FILLER_INDEX);
+        for (int i = 0; i < entries.size(); i++) {
+            blit(sheet, renderSprite(colorTexture, entries.get(i).stack()), GENERATED_START_INDEX + i);
+        }
+    }
+
+    private static @NotNull BufferedImage renderSprite(int colorTexture, @NotNull ItemStack stack) {
+        GL41.glViewport(0, 0, SPRITE_SIZE, SPRITE_SIZE);
+
+        GLRenderer.pushFrame();
+        GLRenderer.projectionM4f().identity().ortho(0.0f, 16.0f, 16.0f, 0.0f, 1000.0f, 3000.0f);
+        GLRenderer.viewM4f().identity().translate(0.0f, 0.0f, -2000.0f);
+        GLRenderer.modelM4f().identity();
+
+        GL41.glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
+        GL41.glClear(GL41.GL_COLOR_BUFFER_BIT | GL41.GL_DEPTH_BUFFER_BIT);
+
+        Lighting.enableInventoryLight();
+        GLRenderer.setColor4f(1.0f, 1.0f, 1.0f, 1.0f);
+        GLRenderer.enableState(State.DEPTH_TEST);
+        try {
+            final ItemModel model = ItemModelDispatcher.getInstance().getDispatch(stack.getItem());
+            model.renderGui(GLRenderer.getTessellator(), null, stack, 0, 0, LightIndexHelper.lightIndex2i(15, 15), 1.0f);
+        } catch (final Exception e) {
+            LOGGER.error("Failed to render inventory sprite for '{}'", stack.getItem().namespaceID, e);
+        }
+        GLRenderer.disableState(State.DEPTH_TEST);
+        Lighting.disable();
+        GLRenderer.popFrame();
+
+        final int size = SPRITE_SIZE * SPRITE_SIZE * 4;
+        Buffer.checkBufferSize(size);
+        final ByteBuffer buffer = Buffer.buffer;
+        buffer.position(0).limit(size);
+        GL41.glPixelStorei(GL41.GL_PACK_ALIGNMENT, 1);
+        GL41.glBindTexture(GL41.GL_TEXTURE_2D, colorTexture);
+        GL41.glGetTexImage(GL41.GL_TEXTURE_2D, 0, GL41.GL_RGBA, GL41.GL_UNSIGNED_BYTE, buffer);
+        buffer.position(0);
+
+        return Textures.getImage(buffer, SPRITE_SIZE, SPRITE_SIZE, true, true);
+    }
+
+    private static void blit(@NotNull BufferedImage sheet, @NotNull BufferedImage sprite, int index) {
+        final int x = (index % COLUMNS) * SPRITE_SIZE;
+        final int y = (index / COLUMNS) * SPRITE_SIZE;
+        final int[] pixels = sprite.getRGB(0, 0, SPRITE_SIZE, SPRITE_SIZE, null, 0, SPRITE_SIZE);
+        sheet.setRGB(x, y, SPRITE_SIZE, SPRITE_SIZE, pixels, 0, SPRITE_SIZE);
+    }
+
+    static int @NotNull [] createFramebuffer() {
+        final int fbo = GL41.glGenFramebuffers();
+        GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, fbo);
+
+        final int colorTexture = GL41.glGenTextures();
+        GL41.glBindTexture(GL41.GL_TEXTURE_2D, colorTexture);
+        GL41.glTexImage2D(GL41.GL_TEXTURE_2D, 0, GL41.GL_RGBA8, SPRITE_SIZE, SPRITE_SIZE, 0, GL41.GL_RGBA, GL41.GL_UNSIGNED_BYTE, (ByteBuffer) null);
+        GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_MIN_FILTER, GL41.GL_NEAREST);
+        GL41.glTexParameteri(GL41.GL_TEXTURE_2D, GL41.GL_TEXTURE_MAG_FILTER, GL41.GL_NEAREST);
+        GL41.glFramebufferTexture2D(GL41.GL_FRAMEBUFFER, GL41.GL_COLOR_ATTACHMENT0, GL41.GL_TEXTURE_2D, colorTexture, 0);
+
+        final int depthBuffer = GL41.glGenRenderbuffers();
+        GL41.glBindRenderbuffer(GL41.GL_RENDERBUFFER, depthBuffer);
+        GL41.glRenderbufferStorage(GL41.GL_RENDERBUFFER, GL41.GL_DEPTH_COMPONENT24, SPRITE_SIZE, SPRITE_SIZE);
+        GL41.glFramebufferRenderbuffer(GL41.GL_FRAMEBUFFER, GL41.GL_DEPTH_ATTACHMENT, GL41.GL_RENDERBUFFER, depthBuffer);
+
+        final int status = GL41.glCheckFramebufferStatus(GL41.GL_FRAMEBUFFER);
+        if (status != GL41.GL_FRAMEBUFFER_COMPLETE) {
+            throw new IllegalStateException("InvSprite framebuffer incomplete: 0x" + Integer.toHexString(status));
+        }
+
+        return new int[]{fbo, colorTexture, depthBuffer};
+    }
+
+    static void destroyFramebuffer(int @NotNull [] fbo) {
+        GL41.glBindFramebuffer(GL41.GL_FRAMEBUFFER, 0);
+        GL41.glDeleteRenderbuffers(fbo[2]);
+        GL41.glDeleteTextures(fbo[1]);
+        GL41.glDeleteFramebuffers(fbo[0]);
+
+        final Minecraft mc = Minecraft.getMinecraft();
+        GL41.glViewport(0, 0, mc.gameWindow.getWidthPixels(), mc.gameWindow.getHeightPixels());
+    }
+
+
+    public record InvSpriteEntry(@NotNull String name, @NotNull ItemStack stack) {}
+
+    public static @NotNull List<InvSpriteEntry> collectInvSpriteEntries() {
+        final I18n i18n = I18n.getInstance();
+        final List<InvSpriteEntry> entries = new ArrayList<>();
+
+        for (final Block<?> block : Blocks.blocksList) {
+            if (block == null || block.id() == 0) continue;
+
+            if (block.getLogic() instanceof IPainted painted && WikiDumper.hasPaintedColorNames(i18n, block.getKey())) {
+                collectPaintedBlockEntries(entries, i18n, block, painted);
+            } else {
+                final String name = i18n.translateKey(block.getKey() + ".name");
+                entries.add(new InvSpriteEntry(name, new ItemStack(block.asItem(), 1, 0)));
+            }
+        }
+
+        for (final Item item : Item.itemsList) {
+            if (item == null) continue;
+            if (item.id < Blocks.blocksList.length) continue;
+            if (item instanceof ItemBucket bucket) {
+                collectBucketEntries(entries, i18n, bucket);
+                continue;
+            }
+            collectItemEntries(entries, i18n, item);
+        }
+
+        return entries;
+    }
+
+    private static void collectPaintedBlockEntries(@NotNull List<InvSpriteEntry> entries, @NotNull I18n i18n,
+                                                   @NotNull Block<?> block, @NotNull IPainted painted) {
+        final String key = block.getKey();
+
+        int minMeta = Integer.MAX_VALUE;
+        for (final DyeColor color : DyeColor.values()) {
+            minMeta = Math.min(minMeta, painted.toMetadata(color));
+        }
+
+        final String mysteryName = i18n.translateKey(key + ".name");
+        entries.add(new InvSpriteEntry(mysteryName, new ItemStack(block.asItem(), 1, minMeta)));
+
+        for (final DyeColor color : DyeColor.values()) {
+            final String colorKey = key + "." + color.colorID;
+            final String colorName = i18n.translateKey(colorKey + ".name");
+            entries.add(new InvSpriteEntry(colorName, new ItemStack(block.asItem(), 1, painted.toMetadata(color))));
+        }
+    }
+
+    private static void collectItemEntries(@NotNull List<InvSpriteEntry> entries, @NotNull I18n i18n, @NotNull Item item) {
+        final String baseKey = item.getKey();
+
+        final Map<String, Integer> variants = new LinkedHashMap<>();
+        for (int meta = 0; meta <= DyeColor.MASK_COLOR; meta++) {
+            String languageKey;
+            try {
+                languageKey = item.getLanguageKey(new ItemStack(item, 1, meta));
+            } catch (final Exception e) {
+                languageKey = baseKey;
+            }
+            if (WikiDumper.hasTranslation(i18n, languageKey + ".name")) {
+                variants.putIfAbsent(languageKey, meta);
+            }
+        }
+
+        final boolean variesByMetadata = variants.size() > 1
+                || (variants.size() == 1 && !variants.containsKey(baseKey));
+
+        if (!variesByMetadata) {
+            entries.add(new InvSpriteEntry(WikiDumper.getWikiDisplayName(item, i18n), new ItemStack(item, 1, 0)));
+            return;
+        }
+
+        if (!variants.containsKey(baseKey) && WikiDumper.hasTranslation(i18n, baseKey + ".name")) {
+            entries.add(new InvSpriteEntry(WikiDumper.getWikiDisplayName(item, i18n), new ItemStack(item, 1, 0)));
+        }
+
+        for (final Map.Entry<String, Integer> variant : variants.entrySet()) {
+            final String name = i18n.translateKey(variant.getKey() + ".name");
+            entries.add(new InvSpriteEntry(name, new ItemStack(item, 1, variant.getValue())));
+        }
+    }
+
+    private static void collectBucketEntries(@NotNull List<InvSpriteEntry> entries, @NotNull I18n i18n, @NotNull ItemBucket bucket) {
+        entries.add(new InvSpriteEntry(i18n.translateKey(bucket.getKey() + ".name"), new ItemStack(bucket, 1, 0)));
+
+        for (final NamespaceID stateId : ItemBucket.getRegisteredStateIds()) {
+            if (ItemBucket.STATE_EMPTY.equals(stateId)) continue;
+
+            final ItemStack sample = ItemBucket.createItemStack(bucket, stateId, 1);
+            final String stateName = i18n.translateKey(bucket.getLanguageKey(sample) + ".name");
+
+            for (int charges = 1; charges <= bucket.maxCharges; charges++) {
+                final ItemStack stack = ItemBucket.createItemStack(bucket, stateId, charges);
+                final String name = bucket.maxCharges > 1 ? stateName + " (" + charges + ")" : stateName;
+                entries.add(new InvSpriteEntry(name, stack));
+            }
+        }
+    }
+
+    static @NotNull Map<Block<?>, BlockColor> applyBiomeSeasonColors() {
+        final BlockColorDispatcher dispatcher = BlockColorDispatcher.getInstance();
+        final Map<String, Integer> colorByColorizer = new HashMap<>();
+        final Map<Block<?>, BlockColor> originals = new LinkedHashMap<>();
+
+        for (final Block<?> block : Blocks.blocksList) {
+            if (block == null) continue;
+            if (!dispatcher.hasDispatch(block)) continue;
+            if (!(dispatcher.getDispatch(block) instanceof BlockColorCustom custom)) continue;
+
+            final int color = colorByColorizer.computeIfAbsent(custom.colorizer.name, n -> biomeSeasonColor(custom.colorizer));
+            originals.put(block, custom);
+            dispatcher.addDispatch(block, new BiomeSeasonBlockColor(color));
+        }
+
+        return originals;
+    }
+
+    static void restoreBlockColors(@NotNull Map<Block<?>, BlockColor> originals) {
+        final BlockColorDispatcher dispatcher = BlockColorDispatcher.getInstance();
+        for (final Map.Entry<Block<?>, BlockColor> entry : originals.entrySet()) {
+            dispatcher.addDispatch(entry.getKey(), entry.getValue());
+        }
+    }
+
+    private static int biomeSeasonColor(@NotNull Colorizer colorizer) {
+        final Minecraft mc = Minecraft.getMinecraft();
+        final String base = "/assets/minecraft/textures/colormap/" + colorizer.name + "/";
+        final String defaultPath = base + "default.png";
+
+        final TexturePack pack = Colorizers.findTexturePackWithFile(mc, defaultPath);
+        if (pack == null) return 0xFFFFFFFF;
+
+        final String seasonPath = base + Seasons.OVERWORLD_SUMMER.getId().replace('.', '_').toLowerCase() + ".png";
+        ColorMap colorMap = pack.hasFile(seasonPath) ? Colorizers.loadColorData(pack, seasonPath) : null;
+        if (colorMap == null) colorMap = Colorizers.loadColorData(pack, defaultPath);
+        if (colorMap == null) return 0xFFFFFFFF;
+
+        final int rgb = colorMap.getColor(Biomes.OVERWORLD_FOREST.defaultTemperature, Biomes.OVERWORLD_FOREST.defaultHumidity);
+        return 0xFF000000 | (rgb & 0xFFFFFF);
+    }
+
+    private static final class BiomeSeasonBlockColor extends BlockColor {
+        private final int color;
+
+        private BiomeSeasonBlockColor(int color) {
+            this.color = color;
+        }
+
+        @Override
+        public int getFallbackColor(int meta, int tintIndex) {
+            return this.color;
+        }
+
+        @Override
+        public int getWorldColor(@NotNull WorldSource source, @NotNull TilePosc tilePos, int tintIndex) {
+            return this.color;
+        }
+    }
+
+    private static @NotNull String escape(@NotNull String value) {
+        return value
+                .replace("\\", "\\\\")
+                .replace("\"", "\\\"")
+                .replace("\r", " ")
+                .replace("\n", " ");
+    }
+}
